<template>
  <div class="mod-config">
    <basic-container>
      <ttable
        :table="table"
        @handleSelectionChange="handleSelectionChange"
        @customUploadPage="structureImport"
        :uploadInfo="uploadInfo"
        :customUpload="customUpload"
        :prelang="prelang"
        :options="options"
        :ajaxFun="ajaxFun"
        ref="structureTable"
      >
        <template #toolbar>
          <!-- <el-button type="primary" :loading="ifsSynsLoading" @click="syncIfs"
            >ERP同步</el-button
          > -->
        </template>
      </ttable>
      <!-- 弹窗, 新增 / 修改 -->
      <!--<table-form v-if="addOrUpdateVisible" ref="addOrUpdate" @refreshDataList="getData"></table-form>-->
      <el-dialog
        title="导入"
        :visible.sync="importStructureVisible"
        width="50%"
      >
        <span>
          <div style="display:flex;justify-content:space-around;">
            <div>
              <el-upload
                style="margin-left:8px;display: inline;"
                class="upload-demo"
                drag
                :headers="headers"
                :action="zhuangbeiUploadInfo.url"
                :beforeUpload="beforeAvatarUpload"
                :limit="1"
                :show-file-list="false"
                :file-list="zhuangbeifileList"
                :data="zhuangbeiUploadInfo.uploadData"
                :on-success="zhuangbeiFileSuccessUploadScan"
                :on-error="handleError"
                accept=".xlsx,.xls,.csv, application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel"
                :auto-upload="true"
                ref="zhuangbeiUploadScan"
                multiple
              >
                <i class="el-icon-upload"></i>
                <div class="el-upload__text"><em>导入产品结构数据</em></div>
                <div class="el-upload__tip" slot="tip">
                  只能上传xlsx/xls文件，且不超过10M<el-button
                    type="text"
                    style="font-size:12px;"
                    @click="downZhuangbeiDataTemplate"
                    >下载模板</el-button
                  >
                </div>
              </el-upload>
            </div>
            <!-- <div>
              <el-upload
                style="margin-left:8px;display: inline;"
                class="upload-demo"
                drag
                :headers="headers"
                :action="shepinUploadInfo.url"
                :beforeUpload="beforeAvatarUpload"
                :limit="1"
                :show-file-list="false"
                :file-list="shepinfileList"
                :data="shepinUploadInfo.uploadData"
                :on-success="shepinFileSuccessUploadScan"
                :on-error="handleError"
                accept=".xlsx,.xls,.csv, application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel"
                :auto-upload="true"
                ref="shepinUploadScan"
                multiple
              >
                <i class="el-icon-upload"></i>
                <div class="el-upload__text"><em>导入射频数据</em></div>
                <div class="el-upload__tip" slot="tip">
                  只能上传xlsx/xls文件，且不超过10M<el-button
                    type="text"
                    style="font-size:12px;"
                    @click="downShepinDataTemplate"
                    >下载模板</el-button
                  >
                </div>
              </el-upload>
            </div> -->
          </div>
        </span>
      </el-dialog>
    </basic-container>
  </div>
</template>
<style>
.dividerClass {
  height: 25em;
  margin: 0 0%;
}
</style>
<script>
import {
  delObj,
  fetchList,
  exportStructureTemplate,
  structureIfsSync
} from '@/api/technology/structure'
import ttable from '@/views/common/ztt-table.vue'
import { mapGetters } from 'vuex'
import ElButton from '../../../../node_modules/element-ui/packages/button/src/button.vue'
import ElInput from '../../../../node_modules/element-ui/packages/input/src/input.vue'
import { copyStructureSave } from '../../../api/technology/structure'
import { remote } from '@/api/admin/dict'
import { getStore } from '@/util/store.js'
import { uploadTemplate } from '@/api/basic/template'
export default {
  data() {
    return {
      ajaxFun: fetchList,
      dataForm: {
        key: ''
      },
      addOrUpdateVisible: false,
      multipleSelection: [],
      isShowQuery: false,
      customUpload: true,
      uploadInfo: {
        // 是否展示上传EXCEL以及对应的url
        isShow: true,
        url: '/mes/structure/uploadExt'
      },
      prelang: 'operation',
      options: {
        height: 300, // 默认高度-为了表头固定
        stripe: true, // 是否为斑马纹 table
        highlightCurrentRow: false, // 是否要高亮当前行
        border: true, // 是否有纵向边框
        lazy: false, // 是否需要懒加载
        fit: true, // 列的宽度是否自撑开
        multiSelect: true, //
        seqNo: true,
        isRefresh: true, // 是否显示刷新按钮
        isShowHide: true, // 是否显示显影按钮
        isSearch: false, // 高级查询按钮
        defaultOrderBy: { column: 'id', direction: 'desc' }
      },
      table: {
        total: 0,
        currentPage: 1,
        pageSize: 20,
        data: [],
        // 标题
        column: [
          // 零件号
          {
            minWidth: '140',
            prop: 'partNo',
            label: '零件号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text',
            render: { fun: this.addOrUpdateHandle }
          },

          {
            minWidth: '140',
            prop: 'partName',
            label: '零件名称',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '140',
            prop: 'version',
            label: '版本号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // 结构类型
          {
            minWidth: '120',
            prop: 'bomTypeDb',
            label: '结构类型',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'select',
            formatter: this.formatBomTypeDbType,
            optList: () => {
              return this.bomTypeDbOptions
            }
          },
          // // 替代
          // {
          //   minWidth: '120',
          //   prop: 'alternativeNo',
          //   label: '替代',
          //   sort: true,
          //   isTrue: true,
          //   isSearch: true,
          //   searchInfoType: 'text'
          // },
          // // 替代描述
          // {
          //   minWidth: '120',
          //   prop: 'alternativeDesc',
          //   label: '替代描述',
          //   sort: true,
          //   isTrue: true,
          //   isSearch: true,
          //   searchInfoType: 'text'
          // },
          // 是否已同步至ERP
          // {
          //   minWidth: '120',
          //   prop: 'ifsSync',
          //   label: '已同步至ERP',
          //   sort: true,
          //   isTrue: true,
          //   isSearch: true,
          //   searchInfoType: 'select',
          //   optList: () => {
          //     return this.getIfsSyncOptionList()
          //   },
          //   formatter: (row, column, cellValue) => {
          //     return cellValue == true ? '是' : '否'
          //   }
          // },
          // 是否为默认结构
          {
            minWidth: '120',
            prop: 'master',
            label: '默认结构',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'select',
            optList: () => {
              return this.getMasterOptionList()
            },
            formatter: (row, column, cellValue) => {
              return cellValue == true ? '是' : '否'
            }
          },
          // 描述
          {
            minWidth: '120',
            prop: 'remark',
            label: '备注',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text',
            noShowTip: false
          }
        ],
        toolbar: [
          {
            text: '新增',
            // icon: 'el-icon-plus',
            type: 'primary',
            fun: this.addOrUpdateHandle,
            disabled: false,
            permitArr: []
          },
          {
            text: '复制',
            fun: this.copyStructure,
            disabled: false,
            permitArr: []
          }
        ],
        operator: [
          {
            text: '删除',
            type: 'text',
            size: 'small',
            fun: this.deleteHandle
          }
        ],
        operatorConfig: {
          fixed: 'right',
          label: '操作',
          width: 100,
          minWidth: 100
        }
      },
      masterOptionList: [
        {
          value: true,
          label: '是'
        },
        {
          value: false,
          label: '否'
        }
      ],
      bomTypeDbOptions: [],
      ifsSyncOptionList: [
        {
          value: true,
          label: '是'
        },
        {
          value: false,
          label: '否'
        }
      ],
      importStructureVisible: false,
      headers: {
        Authorization: 'Bearer ' + getStore({ name: 'access_token' })
      },
      shepinUploadInfo: {
        // 是否展示上传EXCEL以及对应的url
        isShow: true,
        url: '/mes/structure/upload'
      },
      zhuangbeiUploadInfo: {
        // 是否展示上传EXCEL以及对应的url
        isShow: true,
        url: '/mes/structure/uploadExt'
      },
      zhuangbeifileList: [],
      shepinfileList: [],
      ifsSynsLoading: false
    }
  },
  components: {
    ElInput,
    ElButton,
    ttable
  },
  computed: {
    ...mapGetters(['permissions'])
  },
  activated() {
    this.getData()
  },
  created() {
    this.table.column.find((e) => e.label === '已同步至ERP').isTrue = false
    this.getBomTypeDbOptions()
  },
  methods: {
    // 获取数据列表
    getData() {
      if (this.$refs.structureTable !== undefined) {
        this.$refs.structureTable.getDataList()
      }
    },
    // 查看记录详情
    queryDetail(row) {
      this.$router.push({
        name: 'structureDetail',
        params: { id: row == null ? null : row.id }
      })
    },
    // 新增 / 修改
    addOrUpdateHandle(row) {
      this.$router.push({
        name: 'singleStructureForm',
        params: { id: row == null ? null : row.id }
      })
      // this.$router.push({name:"structureForm",query:{id:row==null?null:row.id}})
    },
    // 删除
    deleteHandle(row) {
      this.$confirm('是否确认删除ID为' + row.id, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        closeOnClickModal: false,
        type: 'warning'
      })
        .then(function() {
          return delObj(row.id)
        })
        .then((response) => {
          var data = response.data
          if (data.code == 0) {
            this.$message.success('删除成功')
          } else {
            this.$message.error('删除失败')
          }
          this.getData()
        })
    },
    getMasterOptionList() {
      return this.masterOptionList
    },
    getIfsSyncOptionList() {
      return this.ifsSyncOptionList
    },
    // 复制产品结构
    copyStructure() {
      if (this.multipleSelection != null && this.multipleSelection) {
        copyStructureSave(this.multipleSelection).then((response) => {
          var data = response.data
          if (data.code == 0) {
            this.$message.success('复制成功')
            this.getData()
          } else {
            this.$message.error('复制失败')
          }
        })
      }
    },
    // 获取选择的行
    handleSelectionChange(val) {
      // 根据状态，禁用表头按钮
      // 筛选出选中记录的状态
      var stateArr = val.map(function(value, index) {
        return value.state
      })
      // 选中状态数组元素去重
      var uniqueStateArr = []
      for (var i = 0; i < stateArr.length; i++) {
        if (uniqueStateArr.indexOf(stateArr[i]) == -1) {
          uniqueStateArr.push(stateArr[i])
        }
      }
      // 循环表头按钮，判断每个按钮的permitArr是否完全包含选中状态，若完全包含，则按钮亮，否则按钮灰
      var toolbar = this.table.toolbar
      for (var j = 0; j < toolbar.length; j++) {
        if (
          uniqueStateArr.every((val) =>
            toolbar[j].permitArr.length <= 0
              ? true
              : toolbar[j].permitArr.includes(val)
          )
        ) {
          toolbar[j].disabled = false
        } else {
          toolbar[j].disabled = true
        }
      }
      // 将选中记录赋值给multipleSelection
      this.multipleSelection = val
    },
    getBomTypeDbOptions() {
      remote('bom_type_db').then((response) => {
        if (response.data.code === 0) {
          this.bomTypeDbOptions = response.data.data
        } else {
          this.bomTypeDbOptions = []
        }
      })
    },
    // 工艺类型中文格式化
    formatBomTypeDbType(row, column, cellValue) {
      this.bomTypeDbOptions.forEach((obj) => {
        if (obj.value === cellValue) {
          cellValue = obj.label
        }
      })
      return cellValue
    },
    // 打开产品结构导入
    structureImport() {
      this.importStructureVisible = true
    },
    // 限制文件上传大小，目前限制为10M（另可以加类型限制）
    beforeAvatarUpload(file) {
      const fileName = file.name
      const fileType = fileName.substring(fileName.lastIndexOf('.') + 1)
      const isLt10M = file.size / 1024 / 1024 < 10
      if (fileType !== 'xlsx' && fileType !== 'xls') {
        this.$message.error('文件格式只能为xlsx或xls,请删除后重新上传')
      }
      if (!isLt10M) {
        this.$message({
          message: '文件大小',
          type: 'warning'
        })
      }
      return isLt10M
    },
    // 文件上传成功回调事件
    zhuangbeiFileSuccessUploadScan(response, file, fileList) {
      if (response.code != '0') {
        this.$message.warning(response.msg)
      } else {
        this.$message({
          message: '上传成功',
          type: 'success'
        })
        this.getData()
      }
      this.$refs.zhuangbeiUploadScan.clearFiles()
    },
    // 上传失败
    handleError(err, file, fileList) {
      const error = JSON.parse(err.message)
      if (error.msg) {
        this.$message.error(error.msg)
      } else {
        this.$message.error('上传失败')
      }
    },
    // 下载装备数据模板
    downZhuangbeiDataTemplate() {
      const path = this.$route.path
      const pathElArr = path.split('/')
      // const query = { fileName: pathElArr[2] }

      uploadTemplate(pathElArr[2]).then((response) => {
        const blob = new Blob([response.data], {
          type: 'application/force-download'
        })
        const filename = decodeURI('模板文件.xlsx')
        // 创建一个超链接，将文件流赋进去，然后实现这个超链接的单击事件
        const elink = document.createElement('a')
        elink.download = filename
        elink.style.display = 'none'
        elink.href = URL.createObjectURL(blob)
        document.body.appendChild(elink)
        elink.click()
        URL.revokeObjectURL(elink.href) // 释放URL 对象
        document.body.removeChild(elink)
      })
    },
    // 射频文件上传成功回调事件
    shepinFileSuccessUploadScan(response, file, fileList) {
      if (response.code != '0') {
        this.$message.warning(response.msg)
      } else {
        this.$message({
          message: '上传成功',
          type: 'success'
        })
        this.getData()
      }
      this.$refs.shepinUploadScan.clearFiles()
    },
    // 下载射频数据模板
    downShepinDataTemplate() {
      exportStructureTemplate().then((response) => {
        const blob = new Blob([response.data], {
          type: 'application/force-download'
        })
        const filename = decodeURI('模板文件.xlsx')
        // 创建一个超链接，将文件流赋进去，然后实现这个超链接的单击事件
        const elink = document.createElement('a')
        elink.download = filename
        elink.style.display = 'none'
        elink.href = URL.createObjectURL(blob)
        document.body.appendChild(elink)
        elink.click()
        URL.revokeObjectURL(elink.href) // 释放URL 对象
        document.body.removeChild(elink)
      })
    },
    syncIfs() {
      if (this.multipleSelection != null && this.multipleSelection.length > 0) {
        if (this.multipleSelection.length <= 15) {
          this.ifsSynsLoading = true
          const ids = []
          this.multipleSelection.forEach((item) => {
            ids.push(item.id)
          })
          structureIfsSync(ids)
            .then((response) => {
              const resData = response.data
              if (resData.code === 0) {
                this.$message.success('ERP同步成功')
                this.getData()
              } else {
                this.$message.error('ERP同步失败')
              }
              this.ifsSynsLoading = false
            })
            .catch(() => {
              this.ifsSynsLoading = false
            })
        } else {
          this.$message.error('最多可同时同步15条产品结构')
        }
      } else {
        this.$message.error('请先选择产品结构')
      }
    }
  }
}
</script>
